<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <title>06 API sample cho Pizza 365 Project - v2.8</title>
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>

  <!-- file html dùng để thử tác động của javascript vào các thành phần trang web-->
  <script>
    "use strict";
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
    // lấy danh sách order
    function onBtnGetAllOrderClick() {
      "use strict";
      //base url
      const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

      // create a request
      var vXmlHttpGetAllOrder = new XMLHttpRequest();
      vXmlHttpGetAllOrder.open("GET", vBASE_URL, true);
      vXmlHttpGetAllOrder.send();
      vXmlHttpGetAllOrder.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_STATUS_OK
        ) {
          var vOrderList = vXmlHttpGetAllOrder.responseText;
          console.log(vOrderList);
        }
      };
    }

    // tạo một order mới
    function onBtnCreateOrderClick() {
      "use strict";
      // khai báo object order để chứa thông tin đặt hàng với 14 thuộc tính
      var vObjectRequest = {
        fullName: "Phạm Thanh Bình",
        email: "binhpt001@devcamp.edu.vn",
        address: "Hà Nội",
        phone: "0865241654",
        pizzaSize: "M",
        pizzaType: "Hawai",
        voucher: "651bf6e8c33442d208814abf",
        drink: "651beed3b7859e924976f325",
        status: "cancel",
      };

      var vXmlHttpCreateOrder = new XMLHttpRequest();
      vXmlHttpCreateOrder.open(
        "POST",
        "http://localhost:8000/devcamp-pizza365/orders",
        true
      );
      vXmlHttpCreateOrder.setRequestHeader(
        "Content-Type",
        "application/json;charset=UTF-8"
      );
      vXmlHttpCreateOrder.send(JSON.stringify(vObjectRequest));
      vXmlHttpCreateOrder.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_CREATE_SUCCESS
        ) {
          // status 201 tao thanh cong
          var vCreatedOrder = vXmlHttpCreateOrder.responseText;
          console.log(vCreatedOrder);
        }
      };
    }

    // lấy thông tin đơn hàng (order) theo orderCode (mã đơn hàng)
    function onBtnGetOrderByOrderCodeClick() {
      "use strict";
      //base url
      const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
      var vOrderCode = "hdZJRBKkPS";

      var vXmlHttpGetOrderById = new XMLHttpRequest();
      vXmlHttpGetOrderById.open("GET", vBASE_URL + "/" + vOrderCode, true);
      vXmlHttpGetOrderById.send();
      vXmlHttpGetOrderById.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_STATUS_OK
        ) {
          console.log(vXmlHttpGetOrderById.responseText);
        }
      };
    }

    //update một order mới, sử dụng id
    function onBtnUpdateOrderClick() {
      "use strict";
      //base url
      const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
      var vId = 66684; //  là id (66684) của đơn hàng (không phải là orderCode (mã đơn hàng: hdZJRBKkPS))
      // xem chuỗi response Text
      /* 
         {"id":66684,"orderCode":"hdZJRBKkPS","kichCo":"M","duongKinh":"25","suon":4,"salad":"300","loaiPizza":"HAWAII","idVourcher":"16512",
         "thanhTien":200000,"giamGia":20000,"idLoaiNuocUong":"PEPSI","soLuongNuoc":3,"hoTen":"Phạm Thanh Bình","email":"binhpt001@devcamp.edu.vn","soDienThoai":"0865241654",
         "diaChi":"Hà Nội","loiNhan":"Pizza đế dày","trangThai":"open","ngayTao":1669276471561,"ngayCapNhat":1669276471561}
         */
      var vObjectRequest = {
        trangThai: "confirmed", //3 trạng thái: open, confirmed, cancel
      };

      var vXmlHttpUpdateOrder = new XMLHttpRequest();
      vXmlHttpUpdateOrder.open("PUT", vBASE_URL + "/" + vId);
      vXmlHttpUpdateOrder.setRequestHeader(
        "Content-Type",
        "application/json;charset=UTF-8"
      );
      vXmlHttpUpdateOrder.send(JSON.stringify(vObjectRequest));
      vXmlHttpUpdateOrder.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_STATUS_OK
        ) {
          var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
          console.log(vUpdatedOrder);
        }
      };
    }

    //check mã giảm giá
    function onBtnCheckVoucherIdClick() {
      "use strict";
      const vBASE_URL =
        "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail";
      var vVoucherId = "12332"; //một số mã đúng để test: 95531, 81432,...lưu ý test cả mã sai
      // nếu mã giảm giấ đã nhập, tạo xmlHttp  request và gửi về server
      var vXmlHttp = new XMLHttpRequest();
      vXmlHttp.open("GET", vBASE_URL + "/" + vVoucherId, false);
      vXmlHttp.send(null);
      var vStatusCode = vXmlHttp.status;
      if (vStatusCode == gREQUEST_STATUS_OK) {
        // restFullAPI successful
        // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
        console.log(vXmlHttp.responseText);
      } else {
        // không nhận lại được data do vấn đề gì đó: khả năng mã voucher không dúng
        console.log("Không tìm thấy voucher " + vVoucherId);
      }
    }

    //mã nguồn để load data drink list (danh sách loại nước uống) về
    function onBtnGetDrinkListClick() {
      "use strict";
      var vXhttp = new XMLHttpRequest();
      vXhttp.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_STATUS_OK
        ) {
          console.log(vXhttp.responseText); //ghi response text ra console.log
        }
      };
      vXhttp.open("GET", "http://localhost:8000/devcamp-pizza365/drinks", true);
      vXhttp.send();
    }
  </script>

  <body class="bg-light">
    <div class="container">
      <div class="form-group">
        <p id="cmt2dev">Test Page for Javascrip Tasks. F5 to run code.</p>
      </div>
      <div class="form-group">
        <input
          type="button"
          class="btn btn-primary p-2"
          onclick="onBtnGetAllOrderClick()"
          value="Call api get all orders!"
        />
        <input
          type="button"
          class="btn btn-info p-2"
          onclick="onBtnCreateOrderClick()"
          value="Call api create order!"
        />
        <input
          type="button"
          class="btn btn-success p-2"
          onclick="onBtnGetOrderByOrderCodeClick()"
          value="Call api get order by orderCode"
        />
        <input
          type="button"
          class="btn btn-secondary p-2"
          onclick="onBtnUpdateOrderClick()"
          value="Call api update order by id"
        />
        <input
          type="button"
          class="btn btn-danger p-2"
          onclick="onBtnCheckVoucherIdClick()"
          value="Call api check voucher by id!"
        />
        <input
          type="button"
          class="btn btn-success p-2"
          onclick="onBtnGetDrinkListClick()"
          value="Call api Get drink list!"
        />
      </div>
      <div class="form-group">
        <p id="testP" style="font-size: larger;">
          Demo 06 API for Pizza 365 Project:
        </p>
        <ul>
          <li>get all Orders: lấy tất cả orders</li>
          <li>create Order: tạo 1 order</li>
          <li>get Order by orderCode: lấy 1 order bằng orderCode</li>
          <li>update Order: update 01 order by Id</li>
          <li>
            check voucher by ID: check thông tin mã giảm giá, quan trọng là có
            hay không, và % giảm giá
          </li>
          <li>get drink list: lấy danh sách đồ uống</li>
        </ul>
        <strong class="text-danger"> Bật console log để nhìn rõ output </strong>
      </div>
    </div>
  </body>
</html>
